Index: /pykota/trunk/setup.py
===================================================================
--- /pykota/trunk/setup.py (revision 1113)
+++ /pykota/trunk/setup.py (revision 1144)
@@ -1,3 +1,4 @@
 #! /usr/bin/env python
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota
@@ -23,4 +24,7 @@
 #
 # $Log$
+# Revision 1.24  2003/10/07 09:07:27  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.23  2003/07/29 20:55:17  jalet
 # 1.14 is out !
Index: /pykota/trunk/pykota/loggers/__init__.py
===================================================================
--- /pykota/trunk/pykota/loggers/__init__.py (revision 952)
+++ /pykota/trunk/pykota/loggers/__init__.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
Index: /pykota/trunk/pykota/loggers/stderr.py
===================================================================
--- /pykota/trunk/pykota/loggers/stderr.py (revision 952)
+++ /pykota/trunk/pykota/loggers/stderr.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.4  2003/10/07 09:07:29  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.3  2003/04/23 22:13:57  jalet
 # Preliminary support for LPRng added BUT STILL UNTESTED.
Index: /pykota/trunk/pykota/loggers/system.py
===================================================================
--- /pykota/trunk/pykota/loggers/system.py (revision 1068)
+++ /pykota/trunk/pykota/loggers/system.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.8  2003/10/07 09:07:29  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.7  2003/07/07 11:49:24  jalet
 # Lots of small fixes with the help of PyChecker
Index: /pykota/trunk/pykota/requesters/snmp.py
===================================================================
--- /pykota/trunk/pykota/requesters/snmp.py (revision 1068)
+++ /pykota/trunk/pykota/requesters/snmp.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota - Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.12  2003/10/07 09:07:29  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.11  2003/07/07 11:49:24  jalet
 # Lots of small fixes with the help of PyChecker
Index: /pykota/trunk/pykota/requesters/__init__.py
===================================================================
--- /pykota/trunk/pykota/requesters/__init__.py (revision 952)
+++ /pykota/trunk/pykota/requesters/__init__.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
Index: /pykota/trunk/pykota/requesters/external.py
===================================================================
--- /pykota/trunk/pykota/requesters/external.py (revision 1068)
+++ /pykota/trunk/pykota/requesters/external.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota - Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.9  2003/10/07 09:07:29  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.8  2003/07/07 11:49:24  jalet
 # Lots of small fixes with the help of PyChecker
Index: /pykota/trunk/pykota/tool.py
===================================================================
--- /pykota/trunk/pykota/tool.py (revision 1140)
+++ /pykota/trunk/pykota/tool.py (revision 1144)
@@ -1,3 +1,4 @@
-#! /usr/bin/env python
+# PyKota
+# -*- coding: ISO-8859-15 -*-
 
 # PyKota - Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.52  2003/10/07 09:07:28  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.51  2003/10/06 14:21:41  jalet
 # Test reversed to not retrieve group members when no messages for them.
Index: /pykota/trunk/pykota/reporters/__init__.py
===================================================================
--- /pykota/trunk/pykota/reporters/__init__.py (revision 1048)
+++ /pykota/trunk/pykota/reporters/__init__.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
Index: /pykota/trunk/pykota/reporters/text.py
===================================================================
--- /pykota/trunk/pykota/reporters/text.py (revision 1068)
+++ /pykota/trunk/pykota/reporters/text.py (revision 1144)
@@ -1,3 +1,4 @@
-#! /usr/bin/env python
+# PyKota
+# -*- coding: ISO-8859-15 -*-
 
 # PyKota - Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.5  2003/10/07 09:07:29  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.4  2003/07/07 11:49:24  jalet
 # Lots of small fixes with the help of PyChecker
Index: /pykota/trunk/pykota/__init__.py
===================================================================
--- /pykota/trunk/pykota/__init__.py (revision 952)
+++ /pykota/trunk/pykota/__init__.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
Index: /pykota/trunk/pykota/accounters/stupid.py
===================================================================
--- /pykota/trunk/pykota/accounters/stupid.py (revision 1041)
+++ /pykota/trunk/pykota/accounters/stupid.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota - Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.5  2003/10/07 09:07:29  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.4  2003/06/25 14:10:01  jalet
 # Hey, it may work (edpykota --reset excepted) !
Index: /pykota/trunk/pykota/accounters/__init__.py
===================================================================
--- /pykota/trunk/pykota/accounters/__init__.py (revision 973)
+++ /pykota/trunk/pykota/accounters/__init__.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
Index: /pykota/trunk/pykota/accounters/external.py
===================================================================
--- /pykota/trunk/pykota/accounters/external.py (revision 1123)
+++ /pykota/trunk/pykota/accounters/external.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota - Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.7  2003/10/07 09:07:28  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.6  2003/09/04 07:57:18  jalet
 # Problem with Python 2.3 fixed : a bug of me.
Index: /pykota/trunk/pykota/accounters/querying.py
===================================================================
--- /pykota/trunk/pykota/accounters/querying.py (revision 1068)
+++ /pykota/trunk/pykota/accounters/querying.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota - Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.6  2003/10/07 09:07:29  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.5  2003/07/07 11:49:24  jalet
 # Lots of small fixes with the help of PyChecker
Index: /pykota/trunk/pykota/logger.py
===================================================================
--- /pykota/trunk/pykota/logger.py (revision 1068)
+++ /pykota/trunk/pykota/logger.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.9  2003/10/07 09:07:28  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.8  2003/07/07 11:49:24  jalet
 # Lots of small fixes with the help of PyChecker
Index: /pykota/trunk/pykota/requester.py
===================================================================
--- /pykota/trunk/pykota/requester.py (revision 1068)
+++ /pykota/trunk/pykota/requester.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.9  2003/10/07 09:07:28  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.8  2003/07/07 11:49:24  jalet
 # Lots of small fixes with the help of PyChecker
Index: /pykota/trunk/pykota/storages/pgstorage.py
===================================================================
--- /pykota/trunk/pykota/storages/pgstorage.py (revision 1137)
+++ /pykota/trunk/pykota/storages/pgstorage.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.18  2003/10/07 09:07:30  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.17  2003/10/06 13:12:28  jalet
 # More work on caching
Index: /pykota/trunk/pykota/storages/__init__.py
===================================================================
--- /pykota/trunk/pykota/storages/__init__.py (revision 952)
+++ /pykota/trunk/pykota/storages/__init__.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
Index: /pykota/trunk/pykota/storages/ldapstorage.py
===================================================================
--- /pykota/trunk/pykota/storages/ldapstorage.py (revision 1141)
+++ /pykota/trunk/pykota/storages/ldapstorage.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.31  2003/10/07 09:07:30  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.30  2003/10/06 14:42:36  jalet
 # LDAP group access will be slower when cache is disabled, but at least code
Index: /pykota/trunk/pykota/reporter.py
===================================================================
--- /pykota/trunk/pykota/reporter.py (revision 1048)
+++ /pykota/trunk/pykota/reporter.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.2  2003/10/07 09:07:28  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.1  2003/06/30 12:46:15  jalet
 # Extracted reporting code.
Index: /pykota/trunk/pykota/accounter.py
===================================================================
--- /pykota/trunk/pykota/accounter.py (revision 1083)
+++ /pykota/trunk/pykota/accounter.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.5  2003/10/07 09:07:28  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.4  2003/07/14 14:14:59  jalet
 # Old template
Index: /pykota/trunk/pykota/storage.py
===================================================================
--- /pykota/trunk/pykota/storage.py (revision 1137)
+++ /pykota/trunk/pykota/storage.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.23  2003/10/07 09:07:28  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.22  2003/10/06 13:12:27  jalet
 # More work on caching
Index: /pykota/trunk/pykota/config.py
===================================================================
--- /pykota/trunk/pykota/config.py (revision 1130)
+++ /pykota/trunk/pykota/config.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
@@ -21,4 +22,7 @@
 #
 # $Log$
+# Revision 1.37  2003/10/07 09:07:28  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.36  2003/10/02 20:23:18  jalet
 # Storage caching mechanism added.
Index: /pykota/trunk/pykota/version.py
===================================================================
--- /pykota/trunk/pykota/version.py (revision 1138)
+++ /pykota/trunk/pykota/version.py (revision 1144)
@@ -1,3 +1,4 @@
 # PyKota
+# -*- coding: ISO-8859-15 -*-
 #
 # PyKota : Print Quotas for CUPS and LPRng
Index: /pykota/trunk/bin/warnpykota
===================================================================
--- /pykota/trunk/bin/warnpykota (revision 1117)
+++ /pykota/trunk/bin/warnpykota (revision 1144)
@@ -1,3 +1,4 @@
 #! /usr/bin/env python
+# -*- coding: ISO-8859-15 -*-
 
 # PyKota Print Quota Warning sender
@@ -23,4 +24,7 @@
 #
 # $Log$
+# Revision 1.24  2003/10/07 09:07:28  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.23  2003/08/18 16:35:28  jalet
 # New pychecker pass, on the tools this time.
Index: /pykota/trunk/bin/edpykota
===================================================================
--- /pykota/trunk/bin/edpykota (revision 1133)
+++ /pykota/trunk/bin/edpykota (revision 1144)
@@ -1,3 +1,4 @@
 #! /usr/bin/env python
+# -*- coding: ISO-8859-15 -*-
 
 # PyKota Print Quota Editor 
@@ -23,4 +24,7 @@
 #
 # $Log$
+# Revision 1.59  2003/10/07 09:07:27  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.58  2003/10/03 12:27:01  jalet
 # Several optimizations, especially with LDAP backend
Index: /pykota/trunk/bin/pykota
===================================================================
--- /pykota/trunk/bin/pykota (revision 1124)
+++ /pykota/trunk/bin/pykota (revision 1144)
@@ -1,3 +1,4 @@
 #! /usr/bin/env python
+# -*- coding: ISO-8859-15 -*-
 
 # PyKota accounting filter
@@ -23,4 +24,7 @@
 #
 # $Log$
+# Revision 1.41  2003/10/07 09:07:27  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.40  2003/09/04 08:38:56  jalet
 # Added an exception catch to ensure clean close of database even in
Index: /pykota/trunk/bin/pykotme
===================================================================
--- /pykota/trunk/bin/pykotme (revision 1113)
+++ /pykota/trunk/bin/pykotme (revision 1144)
@@ -1,3 +1,4 @@
 #! /usr/bin/env python
+# -*- coding: ISO-8859-15 -*-
 
 # PyKota Print Quota Quote sender
@@ -23,4 +24,7 @@
 #
 # $Log$
+# Revision 1.4  2003/10/07 09:07:27  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.3  2003/07/29 20:55:17  jalet
 # 1.14 is out !
Index: /pykota/trunk/bin/repykota
===================================================================
--- /pykota/trunk/bin/repykota (revision 1117)
+++ /pykota/trunk/bin/repykota (revision 1144)
@@ -1,3 +1,4 @@
 #! /usr/bin/env python
+# -*- coding: ISO-8859-15 -*-
 
 # PyKota Print Quota Reports generator
@@ -23,4 +24,7 @@
 #
 # $Log$
+# Revision 1.44  2003/10/07 09:07:27  jalet
+# Character encoding added to please latest version of Python
+#
 # Revision 1.43  2003/08/18 16:35:28  jalet
 # New pychecker pass, on the tools this time.