Index: pykota/trunk/man/edpykota.1
===================================================================
--- pykota/trunk/man/edpykota.1 (revision 1109)
+++ pykota/trunk/man/edpykota.1 (revision 1167)
@@ -1,8 +1,8 @@
-.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.29.
-.TH EDPYKOTA "1" "June 2003" "C@LL - Conseil Internet & Logiciels Libres" "PyKota Print Quota for CUPS and LPRng"
+.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.33.
+.TH EDPYKOTA "1" "October 2003" "C@LL - Conseil Internet & Logiciels Libres" "PyKota Print Quota for CUPS and LPRng"
 .SH NAME
-edpykota \- manual page for edpykota 1.14_unofficial
+edpykota \- manual page for edpykota 1.15_unofficial
 .SH DESCRIPTION
-edpykota v1.14_unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
+edpykota v1.15_unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
 A Print Quota editor for PyKota.
 .PP
@@ -48,4 +48,6 @@
 some printers. The default value is *, meaning
 all printers.
+You can specify several names or wildcards,
+by separating them with commas.
 .TP
 \fB\-g\fR | \fB\-\-groups\fR
@@ -169,2 +171,14 @@
 .PP
 Please e-mail bugs to: Jerome Alet - alet@librelogiciel.com
+.SH "SEE ALSO"
+The full documentation for
+.B edpykota
+is maintained as a Texinfo manual.  If the
+.B info
+and
+.B edpykota
+programs are properly installed at your site, the command
+.IP
+.B info edpykota
+.PP
+should give you access to the complete manual.
Index: pykota/trunk/man/pykotme.1
===================================================================
--- pykota/trunk/man/pykotme.1 (revision 1109)
+++ pykota/trunk/man/pykotme.1 (revision 1167)
@@ -1,8 +1,8 @@
-.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.29.
-.TH PYKOTME "1" "July 2003" "C@LL - Conseil Internet & Logiciels Libres" "PyKota Print Quota for CUPS and LPRng"
+.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.33.
+.TH PYKOTME "1" "October 2003" "C@LL - Conseil Internet & Logiciels Libres" "PyKota Print Quota for CUPS and LPRng"
 .SH NAME
-pykotme \- manual page for pykotme 1.14_unofficial
+pykotme \- manual page for pykotme 1.15_unofficial
 .SH DESCRIPTION
-pykotme v1.14_unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
+pykotme v1.15_unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Gives print quotes to users.
@@ -26,4 +26,6 @@
 some printers. The default value is *, meaning
 all printers.
+You can specify several names or wildcards,
+by separating them with commas.
 .PP
 examples :
@@ -34,4 +36,11 @@
 the price and size of a job consisting in file1.ps and file2.ps
 which would be sent to the apple printer.
+.IP
+\f(CW$ pykotme --printer apple,hplaser <file1.ps\fR
+.IP
+This will give a print quote to the current user. The quote will show
+the price and size of a job consisting in file1.ps as read from
+standard input, which would be sent to the apple or hplaser
+printer.
 .IP
 \f(CW$ pykotme\fR
@@ -56,2 +65,14 @@
 .PP
 Please e-mail bugs to: Jerome Alet - alet@librelogiciel.com
+.SH "SEE ALSO"
+The full documentation for
+.B pykotme
+is maintained as a Texinfo manual.  If the
+.B info
+and
+.B pykotme
+programs are properly installed at your site, the command
+.IP
+.B info pykotme
+.PP
+should give you access to the complete manual.
Index: pykota/trunk/man/repykota.1
===================================================================
--- pykota/trunk/man/repykota.1 (revision 1109)
+++ pykota/trunk/man/repykota.1 (revision 1167)
@@ -1,8 +1,8 @@
-.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.29.
-.TH REPYKOTA "1" "June 2003" "C@LL - Conseil Internet & Logiciels Libres" "PyKota Print Quota for CUPS and LPRng"
+.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.33.
+.TH REPYKOTA "1" "October 2003" "C@LL - Conseil Internet & Logiciels Libres" "PyKota Print Quota for CUPS and LPRng"
 .SH NAME
-repykota \- manual page for repykota 1.14_unofficial
+repykota \- manual page for repykota 1.15_unofficial
 .SH DESCRIPTION
-repykota v1.14_unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
+repykota v1.15_unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Generates print quota reports.
@@ -32,4 +32,6 @@
 some printers. The default value is *, meaning
 all printers.
+You can specify several names or wildcards,
+by separating them with commas.
 .PP
 examples :
@@ -43,9 +45,9 @@
 This will print the quota status for all users on all printers.
 .IP
-\f(CW$ repykota --printer "laser*" jerome "jo*"\fR
+\f(CW$ repykota --printer "laser*,*pson" jerome "jo*"\fR
 .IP
 This will print the quota status for user jerome and all users
-whose name begins with "jo" on all printers which name begin
-with "laser"
+whose name begins with "jo" on all printers which name begins
+with "laser" or ends with "pson".
 .IP
 If launched by a non-root user, additionnal arguments representing
@@ -68,2 +70,14 @@
 .PP
 Please e-mail bugs to: Jerome Alet - alet@librelogiciel.com
+.SH "SEE ALSO"
+The full documentation for
+.B repykota
+is maintained as a Texinfo manual.  If the
+.B info
+and
+.B repykota
+programs are properly installed at your site, the command
+.IP
+.B info repykota
+.PP
+should give you access to the complete manual.
Index: pykota/trunk/man/warnpykota.1
===================================================================
--- pykota/trunk/man/warnpykota.1 (revision 1109)
+++ pykota/trunk/man/warnpykota.1 (revision 1167)
@@ -1,8 +1,8 @@
-.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.29.
-.TH WARNPYKOTA "1" "June 2003" "C@LL - Conseil Internet & Logiciels Libres" "PyKota Print Quota for CUPS and LPRng"
+.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.33.
+.TH WARNPYKOTA "1" "October 2003" "C@LL - Conseil Internet & Logiciels Libres" "PyKota Print Quota for CUPS and LPRng"
 .SH NAME
-warnpykota \- manual page for warnpykota 1.14_unofficial
+warnpykota \- manual page for warnpykota 1.15_unofficial
 .SH DESCRIPTION
-warnpykota v1.14_unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
+warnpykota v1.15_unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Sends mail to users over print quota.
@@ -33,4 +33,6 @@
 some printers. The default value is *, meaning
 all printers.
+You can specify several names or wildcards,
+by separating them with commas.
 .PP
 examples :
@@ -73,2 +75,14 @@
 .PP
 Please e-mail bugs to: Jerome Alet - alet@librelogiciel.com
+.SH "SEE ALSO"
+The full documentation for
+.B warnpykota
+is maintained as a Texinfo manual.  If the
+.B info
+and
+.B warnpykota
+programs are properly installed at your site, the command
+.IP
+.B info warnpykota
+.PP
+should give you access to the complete manual.