Index: /pykota/trunk/docs/installation.sgml
===================================================================
--- /pykota/trunk/docs/installation.sgml (revision 1168)
+++ /pykota/trunk/docs/installation.sgml (revision 1187)
@@ -29,7 +29,7 @@
     have to decompress and visit its archive, to do so just type the following commands :
     <screen>
-jerome@nordine:~$ tar -zxf pykota-1.15_official.tar.gz    
-jerome@nordine:~$ cd pykota-1.15_official
-jerome@nordine:~/pykota-1.15_official$
+jerome@nordine:~$ tar -zxf pykota-1.16_official.tar.gz    
+jerome@nordine:~$ cd pykota-1.16_official
+jerome@nordine:~/pykota-1.16_official$
     </screen>
   </para>
@@ -165,6 +165,6 @@
         From a command line interpreter (i.e. shell), type the following commands :
         <screen>
-jerome@nordine:~$ cd pykota-1.15_official/initscripts/postgresql
-jerome@nordine:~/pykota-1.15_official/initscripts$ psql -h localhost -U postgres template1
+jerome@nordine:~$ cd pykota-1.16_official/initscripts/postgresql
+jerome@nordine:~/pykota-1.16_official/initscripts$ psql -h localhost -U postgres template1
 Welcome to psql, the PostgreSQL interactive terminal.
 
@@ -197,5 +197,5 @@
 ALTER USER
 pykota=# \q
-jerome@nordine:~/pykota-1.15_official/initscripts/postgresql$
+jerome@nordine:~/pykota-1.16_official/initscripts/postgresql$
         </screen>
       </para>
@@ -582,19 +582,15 @@
       
       <para>
-        The easiest way to configure PyKota to be used for a particular <application>CUPS</application> print queue, 
-        is to modify the <literal>PPD</literal> file associated with this print queue.
-        Say you want to set quotas on the <literal>HPLaser</literal> print queue. You
-        then just have to modify the file <filename>/etc/cups/ppd/HPLaser.ppd</filename>.
-        You will have to add the following lines somewhere near the beginning of this file :
-        <screen>
-*% Print Quota System
-*cupsFilter: "application/vnd.cups-postscript    0    /usr/bin/pykota"
-        </screen>
-      </para>  
-      
-      <para>
-        The first line is a comment. The second one tells <application>CUPS</application>
-        to launch PyKota's accounting filter just before sending the print job to 
-        the printer's hardware.
+        From version 1.16alpha7 on, configuring PyKota to integrate
+        within CUPS is more than easy.
+      </para>
+      
+      <para>
+        You just have to create a symbolic link to the <filename>cupspykota</filename>
+        command in CUPS' backend directory :
+        <screen>        
+$ cd /usr/lib/cups/backend        
+$ ln -s /usr/bin/cupspykota cupspykota
+        </screen>
       </para>
       
@@ -608,51 +604,15 @@
       
       <para>
-        Repeat the above procedure for each print queue on which you want to use
-        PyKota. That's all !
-      </para>
-      
-      <sect3>
-        <title>Troubleshooting</title>
-        <para>
-          NB : the above procedure only works with <literal>PPD</literal> files which
-          don't already contain an <literal>*cupsFilter</literal> line. PostScript
-          printers usually don't need this line, but other types of printers may need
-          it. A different procedure exists for such printers, but it is not actually
-          documented. Search the mailing list archives at
-          <ulink url="http://cgi.librelogiciel.com/mailman/listinfo/pykota">
-            http://cgi.librelogiciel.com/mailman/listinfo/pykota
-          </ulink> to learn how to do.
-        </para>
-        
-        <para>
-          In case of problem, the simplest way to solve it is currently
-          to ask on PyKota's mailing list, describing the symptoms, as
-          well as the hardware and software you use.
-          In a future release of this document, a section dedicated to 
-          Frequently Asked Questions will be included.
-        </para>
-      </sect3>  
-      
-    </sect2>
-    
-    <sect2>
-      <title>With LPRng</title>
-      <para>
-        To plug PyKota into your <application>LPRng</application> setup, 
-        you have to modify the <filename>/etc/printcap</filename>.
-        You just have to add the following lines to each queue on 
-        which you want to use PyKota :
-        <screen>
-  :achk=true
-  :as=|/usr/bin/pykota
-        </screen>
-      </para>
-      
-      <para>
-        You have to restart <application>LPRng</application> for this modification to
-        take effect : 
-        <screen>
-$ /etc/init.d/lprng restart        
-        </screen>
+        Now point your web browser to CUPS configuration page, usually at 
+        <ulink url="http://localhost:631">http://localhost:631</ulink> on
+        your print server.
+      </para>
+      
+      <para>
+        Then when creating new printers or reconfiguring existing ones, just
+        choose devices which are <literal>PyKota managed</literal> instead of
+        normal devices. You've got one <literal>PyKota managed</literal> device
+        for each regular device available from CUPS, so just choose the appropriate
+        one.
       </para>
       
@@ -671,4 +631,59 @@
           Frequently Asked Questions will be included.
         </para>
+        
+        <para>
+          You can now also ask us questions on IRC :
+          <screen>
+/server irc.freenode.net          
+/join #pykota
+          </screen>
+        </para>  
+      </sect3>  
+      
+    </sect2>
+    
+    <sect2>
+      <title>With LPRng</title>
+      <para>
+        To plug PyKota into your <application>LPRng</application> setup, 
+        you have to modify the <filename>/etc/printcap</filename>.
+        You just have to add the following lines to each queue on 
+        which you want to use PyKota :
+        <screen>
+  :achk=true
+  :as=|/usr/bin/pykota
+        </screen>
+      </para>
+      
+      <para>
+        You have to restart <application>LPRng</application> for this modification to
+        take effect : 
+        <screen>
+$ /etc/init.d/lprng restart        
+        </screen>
+      </para>
+      
+      <para>
+        Repeat the above procedure for each print queue on which you want to use
+        PyKota. That's all !
+      </para>
+      
+      <sect3>
+        <title>Troubleshooting</title>
+        <para>
+          In case of problem, the simplest way to solve it is currently
+          to ask on PyKota's mailing list, describing the symptoms, as
+          well as the hardware and software you use.
+          In a future release of this document, a section dedicated to 
+          Frequently Asked Questions will be included.
+        </para>
+        
+        <para>
+          You can now also ask us questions on IRC :
+          <screen>
+/server irc.freenode.net          
+/join #pykota
+          </screen>
+        </para>
       </sect3>  
       
@@ -681,4 +696,7 @@
 
 $Log$
+Revision 1.22  2003/11/15 14:59:53  jalet
+Documentation wrt the new CUPS backend.
+
 Revision 1.21  2003/10/14 20:26:53  jalet
 Better documentation.
Index: /pykota/trunk/docs/filterpykota.sgml
===================================================================
--- /pykota/trunk/docs/filterpykota.sgml (revision 1168)
+++ /pykota/trunk/docs/filterpykota.sgml (revision 1187)
@@ -2,5 +2,5 @@
 
 <chapter>
-  <title id="filter">The pykota filter</title>
+  <title id="filter">PyKota's internals</title>
   
   <para>Last modified on $Date$</para>
@@ -49,11 +49,9 @@
   
   <para>
-    Currently with a <application>CUPS</application> backend, the <application>pykota</application> filter is used at the very last stage of the print mechanism,
-    just before the final data is sent to the printer, but it may eventually be used earlier with some
-    modifications to <application>CUPS</application>'s filtering configuration. 
-    You can find in the mailing list archives of July 2003 an explanation on how to do this.
-    This may allow you to use PyKota with a not-PostScript printer or with a PostScript printer
-    which really needs to have
-    a specific filter like <application>magicfilter</application> or <application>cupsomatic</application>.
+    Currently with a <application>CUPS</application> backend, the <application>pykota</application> filter is 
+    deprecated. You have to use the <application>cupspykota</application> CUPS backend instead.
+    This CUPS backend ensures that jobs can't bypass the filtering mechanism, so you can use
+    any printer with any driver and any command line option, and you can be sure that your
+    print job will be correctly accounted for.
   </para>
   
@@ -66,5 +64,5 @@
   
   <para>
-    When you submit a print job, <application>pykota</application> is automatically launched by your printing system,
+    When you submit a print job, <application>cupspykota</application> (with CUPS) or <application>pykota</application> (with LPRng) is automatically launched by your printing system,
     so it has to detect which system you are using (<application>CUPS</application> or <application>LPRng</application>)
     and behave like if it was specifically designed for your printing system. Fortunately there's not a lot
@@ -75,10 +73,14 @@
   <para>
     When using the <literal>querying</literal> accounting method,
-    <application>pykota</application> then asks the printer for its internal page counter, read from the Quota DataBase the internal
+    <application>pykota</application> asks the printer for its internal page counter, reads from the Quota DataBase the internal
     page counter for this printer when the previous job was launched, computes the difference, and report it as the 
     previous job's size in the Quota DataBase. It then updates the last user's print quota and account balance, and
     warn him if he is over quota or if his account balance is below 0. Finally it checks if the user who launched the 
     current job is below or above his print quota, and either allows or denies the job's datas to pass to the underlying 
-    layer (the printer itself).
+    layer (the printer itself). The <application>cupspykota</application> CUPS backend on the other hand,
+    asks the printer for its internal page counter at the start and at the end of the print job, and
+    computes the values' difference so accounting is done immediately. This way it doesn't let open a window for abuse in the case
+    several printers are managed. That's why the use of <application>cupspykota</application>
+    instead of <application>pykota</application> is recommanded with CUPS.
   </para>
   
@@ -106,4 +108,7 @@
 
 $Log$
+Revision 1.8  2003/11/15 14:59:53  jalet
+Documentation wrt the new CUPS backend.
+
 Revision 1.7  2003/10/14 20:26:53  jalet
 Better documentation.